
BallClass = {}

function BallClass.new(b)
	local b = b or {}
	setmetatable(b, {__index=BallClass})
	--PARTICLE
	b.live = false
	b.part = {}
	local partimg = love.graphics.newImage("resources/image/ball.png");
	local _p = love.graphics.newParticleSystem(partimg, 200)
		_p:setEmissionRate(100)
		_p:setSpeed(0, 0)
		_p:setSizes(1, 0.5)
		_p:setColors(220, 105, 20, 255, 194, 30, 18, 0)
		_p:setPosition(300, 240)
		_p:setLifetime(0.1)
		_p:setParticleLife(0.5)
		_p:setDirection(0)
		_p:setSpread(0)
		_p:setTangentialAcceleration(0)
		_p:setRadialAcceleration(2000)
		_p:stop()
	table.insert(b.part, _p)
	local _p = love.graphics.newParticleSystem(partimg, 200)
		_p:setEmissionRate(50)
		_p:setSpeed(0, 0)
		_p:setSizes(0.25, 1)
		_p:setColors(220, 105, 20, 20, 194, 30, 18, 0)
		_p:setLifetime(0.25)
		_p:setParticleLife(0.75)
		_p:setDirection(0)
		_p:setSpread(math.pi/4)
		_p:setTangentialAcceleration(0)
		_p:setRadialAcceleration(0)
		_p:stop()
	table.insert(b.part, _p)
	--RADIUS
	b.r = 10
	--POSITION
	b.p= {}
		b.p.x = love.graphics.getWidth()/2
		b.p.y = love.graphics.getHeight()/2
	--VELOCITY
	b.v = {}
		b.v.x = 0
		b.v.y = 0
	--COLOR
	b.c = {}
		b.c.r = 255
		b.c.g = 255
		b.c.b = 255
		b.c.a = 255
	--Who owns the ball?
	b.own = 0
	--Hit Sound
	b.hitSnd = love.audio.newSource("resources/sound/phit.ogg","static")
	b.upSnd = love.audio.newSource("resources/sound/pup.ogg","static")
	b.dieSnd = love.audio.newSource("resources/sound/pblip.ogg","static")
	return b
end

--Randomly returns 1 or -1
function BallClass:randDir()
	local r
		r = math.random()
		if r<0.5 then
			return -1
		end
		return 1
end

function BallClass:update(dt)
	--Position update
	self.p.x = self.p.x + self.v.x*dt
	self.p.y = self.p.y + self.v.y*dt
	--Particle update
	--self.part[1]:setSpeed(-self.v.x, -self.v.y)
	self.part[1]:setTangentialAcceleration((math.random()-0.5)*1000)
	self.part[2]:setTangentialAcceleration((math.random()-0.5)*2000)
	--self.part[2]:setSpeed(-self.v.x, -self.v.y)
	--Particle position update
	for _,v in ipairs(self.part) do
		v:setDirection(-self.v.x, -self.v.y)
		v:setPosition(self.p.x, self.p.y)
		v:start()
		v:update(dt)
	end
end

function BallClass:collide(dt)
	local b = self
	--http://www.metanetsoftware.com/technique/tutorialA.html#section0

	--Check if it is off screen
	if (b.p.x+b.r) < -40
	or (b.p.x-b.r) > love.graphics.getWidth()+40 then
		if (b.p.x+b.r) < -40 then
			pnt.two = pnt.two+1
		else
			pnt.one = pnt.one+1
		end
		--ADD POINTS
		--PARTICLES!
		for i,v in ipairs(balls) do
			if b==v then
				love.audio.play(v.dieSnd)
				table.remove(balls,i)
				if #balls==0 then
					table.insert(balls, BallClass.new())
				end
				return
			end
		end
	end

	--Collide with ceiling and floor
		if ((b.p.y-b.r) < 0 and b.v.y<0)
		or ((b.p.y+b.r) > love.graphics.getHeight() and b.v.y>0) then
			b.v.y = -b.v.y
			love.audio.play(b.hitSnd)
		end

	--Collide with Paddle
		for i,p in ipairs(paddles) do
			if (b.p.x-b.r <= p.p.x+p.w/2
			and b.p.x+b.r >= p.p.x-p.w/2)
			and (b.p.y-b.r <= p.p.y+p.h/2
			and b.p.y+b.r >= p.p.y-p.h/2) then
				if (b.p.x>love.graphics.getWidth()/2 and b.v.x>0)
				or (b.p.x<love.graphics.getWidth()/2 and b.v.x<0)  then
					b.v.x = -b.v.x
					--local mag = math.sqrt(math.pow(b.v.x,2)+math.pow(b.v.y,2))
					local ratio = math.min(math.max((b.p.y-(p.p.y-p.h/2))/p.h,0),1)
					b.v.y = (ratio-0.5)*400
					--Increase ball speed
					b.v.x = b.v.x+b.v.x*0.05
					b.own = i
					b.part[2]:setColors(p.c.r,p.c.g,p.c.b,p.c.a, 194, 30, 18, 0)
					b.c = p.c
					love.audio.play(b.hitSnd)
				end
			end
		end

	--Collide with Other Balls
		for _,v in ipairs(balls) do
			if v~=b then
				local dis = math.sqrt(math.pow(b.p.x-v.p.x,2)+math.pow(b.p.y-v.p.y,2))
				local dr = b.r+v.r
				if dis < dr then
					b.v.x = -b.v.x
					b.v.y = -b.v.y
					love.audio.play(b.hitSnd)
				end
			end
		end


--Collide with Inactive Upgrades
	for _,v in ipairs(balls) do
		for i,u in ipairs(up.wait) do
			local dis = math.sqrt(math.pow(u.p.x-v.p.x,2)+math.pow(u.p.y-v.p.y,2))
			local dr = u.r+v.r
			if dis < dr then
				--INSERT BALL THAT HIT IT!!!
				u.upg.ball = b
				u.upg.id = b.own
				table.insert(up.active,u.upg)
				table.remove(up.wait,i)
				love.audio.play(self.upSnd)
			--GRAIVTY WELLS
			elseif dis < 100 and balls[1].live==true then
				if v.p.y > u.p.y then
					v.v.y = v.v.y - 150*dt
				else
					v.v.y = v.v.y + 150*dt
				end
			end
		end
	end

end

function BallClass:draw(dt)
	local b = self
	love.graphics.setColor(b.c.r, b.c.g, b.c.b, b.c.a)
	love.graphics.circle("line", b.p.x, b.p.y, b.r, 50)
	love.graphics.setColorMode("modulate")
	love.graphics.setBlendMode("additive")
	for _,v in ipairs(b.part) do
		love.graphics.draw(v, 0, 0)
	end
	if balls[1].live==false then
		love.graphics.setColor(255,255,255,255)
		local x = b.p.x-14
		local y = b.p.y-10
		local fl = math.sin(love.timer.getTime()*3)*5
		love.graphics.draw(spaceimg,x,y+fl-30)
	end
end

function BallClass:start()
	--Never reset a live ball
	if self.live==true then
		return
	end
	--Move to the center of the screen
	--self.p = {}
	--	self.p.x = 300
	--	self.p.y = 240
	--Randomly choose the direction
	self.v = {}
		self.v.x = self:randDir()*200
		self.v.y = 0
	--LET THERE BE LIFE!
	self.live = true
end

function BallClass:reset()
	--Do not reset a dead ball
	if self.live==false then
		return
	end
	--Move to the center
	--self.p.x = love.graphics.getWidth()-self.r
	--self.p.y = love.graphics.getHeight()-self.r
	--Make the ball not move
	self.v.x = 0
	self.v.y = 0
	--KILL IT WITH FIRE!
	self.live = false
	self.part:stop()
end



