
PaddleClass = {}

function PaddleClass.new(p, x, k1, k2, k3, r, g, b, up, dwn)
	local p = p or {}
	local x = x or 300
	setmetatable(p, {__index=PaddleClass})
	--PARTICLE
	p.part = {}
	local partimg = love.graphics.newImage("resources/image/square.png");
	local _p = love.graphics.newParticleSystem(partimg, 200)
		_p:setEmissionRate(100)
		_p:setSpeed(0, 400)
		_p:setSizes(1, 0)
		_p:setColors(r, g, b, 128, r/2, g/2, b/2, 0)
		_p:setLifetime(0.25)
		_p:setParticleLife(0.6)
		_p:setDirection(3*math.pi/2)
		_p:setSpread(math.pi/16)
		_p:setTangentialAcceleration(0)
		_p:setRadialAcceleration(0)
		_p:stop()
	table.insert(p.part, _p)
	local _p = love.graphics.newParticleSystem(partimg, 200)
		_p:setEmissionRate(100)
		_p:setSpeed(0, 400)
		_p:setSizes(1, 0)
		_p:setColors(r, g, b, 128, r/2, g, b, 0)
		_p:setLifetime(0.25)
		_p:setParticleLife(0.6)
		_p:setDirection(math.pi/2)
		_p:setSpread(math.pi/16)
		_p:setTangentialAcceleration(0)
		_p:setRadialAcceleration(0)
		_p:stop()
	table.insert(p.part, _p)
	--SIZE
	p.h = 100
	p.w = 30
	--POSITION
	p.p= {}
		p.p.x = x
		p.p.y = love.graphics.getHeight()/2
	--VELOCITY
	p.v = {}
		p.v.x = 0
		p.v.y = 0
	--COLOR
	p.c = {}
		p.c.r = r
		p.c.g = g
		p.c.b = b
		p.c.a = 255
	--SPEED
	p.spd = 200
	p.rev = false
	--KEYS
	p.k = {}
		p.k.u = k1
		p.k.d = k2
		p.k.b = k3
	--KEY IMAGES
	p.k.up = up
	p.k.dwn = dwn
	return p
end

function PaddleClass:update(dt)
	local p = self
	if love.keyboard.isDown(p.k.u) then
		p.p.y = p.p.y - p.spd*dt
	elseif love.keyboard.isDown(p.k.d) then
		p.p.y = p.p.y + p.spd*dt
	end
	if p.p.y < (p.h/2) then
		p.p.y = (p.h/2)
	elseif p.p.y > love.graphics.getHeight()-(p.h/2) then
		p.p.y = love.graphics.getHeight()-(p.h/2)
	end
	p.part[1]:setPosition(p.p.x, p.p.y+p.h/2-10)
	p.part[2]:setPosition(p.p.x, p.p.y-p.h/2+10)
	for _,v in ipairs(p.part) do
		v:start()
		v:update(dt)
	end
end

function PaddleClass:draw(dt)
	local p = self
	love.graphics.setColor(p.c.r, p.c.g, p.c.b, p.c.a)
	love.graphics.setColorMode("modulate")
	love.graphics.setBlendMode("additive")
	for _,v in ipairs(p.part) do
		love.graphics.draw(v, 0, 0)
	end
	if balls[1].live==false then
		love.graphics.setColor(255,255,255,255)
		local x = p.p.x-10
		local y = p.p.y
		local fl = math.sin(love.timer.getTime()*3)*4
		love.graphics.draw(p.k.up,x,y+fl-p.h/2-40)
		love.graphics.draw(p.k.dwn,x,y-fl+p.h/2+10)
	end
	--love.graphics.rectangle("line", p.p.x-p.w/2, p.p.y-p.h/2, p.w, p.h)
end

function PaddleClass:reset()
	self.p.x = 300
	self.p.y = 240
	self.v.x = 0
	self.v.y = 0
	self.live = false
	self.part:stop()
end

