
UpClass = {}

function UpClass.new(up)
	local up = up or {}
	setmetatable(up, {__index=UpClass})
	--Table of upgrades currently active
	up.active = {}
	--Table of upgrades not activated
	up.wait = {}
	--Time between each try for a spawn
	up.wait.to = 5
	up.wait.t = 3
	return up
end

function UpClass:update(dt)
	--Update each active upgrade
	for i,v in ipairs(self.active) do
		v.update(v,dt)
		if v.time <= 0 then
			table.remove(self.active, i)
		end
	end
	--Progress timer to try an upgrade spawn
	if balls[1].live==true then
		self.wait.t = self.wait.t - dt
	end
	if self.wait.t <= 0 then
		self.wait.t = self.wait.to
		self:Spawn()
	end
	--Update each inactive upgrade
	for i,v in ipairs(self.wait) do
		v.t = v.t - dt
		if v.t <= 0 then
			table.remove(self.wait,i)
		end
		v.p.x = v.p.x + v.v.x*dt
		v.p.y = v.p.y + v.v.y*dt
	end


	for _,v in ipairs(self.wait) do
		v.d.t = v.d.t - (30*dt)
		if v.d.t < 0 then
			v.d.t = v.d.to
		end
		for _,u in ipairs(v.part) do
			u:setDirection(v.d.t)
			u:start()
			u:update(dt)
		end
	end
end

function UpClass:draw(dt)
	--Draw each active upgrade
	for i,v in ipairs(self.active) do

	end
	--Draw each inactive upgrade
	for _,v in ipairs(self.wait) do
		for _,u in ipairs(v.part) do
			love.graphics.draw(u, 0, 0)
		end
	end

end

function UpClass:Spawn()
	local up =  {}
	--Time to keep upgrade alive
	up.t = 20
	--Radius of upgrade
	up.r = 10
	--Position of upgrade
	up.p = {}
		up.p.x = math.random()*(love.graphics.getWidth()-120)+60
		up.p.y = math.random()*(love.graphics.getHeight()-80)+40
	--Velocity of upgrade
	up.v = {}
		up.v.x = 0
		up.v.y = 0
	--Particle system of upgrade
	up.d = {}
	up.d.to = 2*math.pi
	up.d.t = up.d.to
	up.part = {}
		local partimg = love.graphics.newImage("resources/image/ball.png");
		local _p = love.graphics.newParticleSystem(partimg, 200)
			_p:setEmissionRate(100)
			_p:setSpeed(200, 200)
			_p:setSpin(10, 10, 1)
			_p:setSizes(1, 0.5)
			_p:setColors(0,0,0,0, 64, 64, 128, 128)
			_p:setPosition(up.p.x, up.p.y)
			_p:setLifetime(0.01)
			_p:setParticleLife(0.5)
			_p:setDirection(200)
			_p:setSpread(2)
			_p:setTangentialAcceleration(500)
			_p:setRadialAcceleration(-1200)
			_p:stop()
	--Add the new upgrade
	local rand = math.random(2)
	if rand==1 then
		up.upg = GoodUpClass.new()
		--Color of upgrade
		_p:setColors(0,255,0,255, 64, 64, 128, 128)
		up.c = {0,255,0,255}
	else
		up.upg = BadUpClass.new()
		--Color of upgrade
		_p:setColors(255,0,0,255, 64, 64, 128, 128)
		up.c = {255,0,0,255}
	end
		table.insert(up.part, _p)
	table.insert(self.wait, up)
end


