require("lua.backg")
require("lua.upgrade")
require("lua.ball")
require("lua.paddle")
require("lua.goodup")
require("lua.badup")


function love.load()
	math.randomseed(love.timer.getTime())
	love.graphics.setBackgroundColor(30,30,30)
	bg = BackGClass.new()
	ai1 = false
	ai2 = false
	--Points
	pnt = {}
	pnt.one = 0
	pnt.ot = 0
	pnt.op = 0
	pnt.two = 0
	pnt.tt = 0
	pnt.tp = 0
	local fontimg = love.graphics.newImage("resources/font/largenum.png")
	fontimg:setFilter("nearest","nearest")
	font = love.graphics.newImageFont(fontimg, "0123456789")
	love.graphics.setFont(font)
	--Balls
	spaceimg = love.graphics.newImage("resources/image/space.png")
	balls = {}
	table.insert(balls, BallClass.new())
	--Upgrades
	up = UpClass.new()
	--Paddles
	paddles = {}
	local up = love.graphics.newImage("resources/image/w.png")
	local dwn = love.graphics.newImage("resources/image/s.png")
	table.insert(paddles, PaddleClass.new({},20, "w","s","f", 192,64,128,up,dwn))
	local up = love.graphics.newImage("resources/image/up.png")
	local dwn = love.graphics.newImage("resources/image/dwn.png")
	table.insert(paddles, PaddleClass.new({},love.graphics.getWidth()-20, "up","down","rctlr", 0,128,255,up,dwn))

end

function love.update(dt)
	bg:update(dt)
	--AI PADDLES
	if balls[1].live==false and ai1 and ai2 then
		for _,b in ipairs(balls) do
			b:start()
		end
	end
	if ai1 then
		local p = paddles[1]
		if p.p.y+30 < balls[1].p.y then
			p.p.y = p.p.y + p.spd*dt
		elseif p.p.y-30 > balls[1].p.y then
			p.p.y = p.p.y - p.spd*dt
		end
	end
	if ai2 then
		local p = paddles[2]
		if p.p.y < balls[1].p.y then
			p.p.y = p.p.y + p.spd*dt
		elseif p.p.y > balls[1].p.y then
			p.p.y = p.p.y - p.spd*dt
		end
	end
	--PADDLES
	for _,p in ipairs(paddles) do
		p:update(dt)
	end
	--BALLS
	for _,b in ipairs(balls) do
		b:update(dt)
		b:collide(dt)
	end
	--POINTS
	if pnt.op ~= pnt.one then
		pnt.ot = 0.25
		pnt.op = pnt.one
	elseif pnt.ot > 0 then
		pnt.ot = pnt.ot - dt
	end
	if pnt.tp ~= pnt.two then
		pnt.tt = 0.25
		pnt.tp = pnt.two
	elseif pnt.tt > 0 then
		pnt.tt = pnt.tt - dt
	end
	--UPGRADES
	up:update(dt)
end

function love.draw()
		love.graphics.setColor(255,255,255,30)
		bg:draw()
		--SCORES
		local h = love.graphics.getHeight()
		local w = love.graphics.getWidth()
		local fl = 0
	love.graphics.push()
		if pnt.ot>0 or pnt.tt>0 then
			fl = math.random(30)-15
		end
		if pnt.ot > 0 then
			love.graphics.translate(0,fl)
		end
		love.graphics.print(pnt.one,20,-10)
	love.graphics.pop()
	love.graphics.push()
		if pnt.tt > 0 then
			love.graphics.translate(0,fl)
		end
			if pnt.two>99 then
				love.graphics.print(pnt.two,w-500,h-220)
			elseif pnt.two>9 then
				love.graphics.print(pnt.two,w-330,h-220)
			else
				love.graphics.print(pnt.two,w-150,h-220)
			end
	love.graphics.pop()
		--BALLS
		up:draw()
		for _,b in ipairs(balls) do
			b:draw()
		end
		--PADDLES
		for _,p in ipairs(paddles) do
			p:draw()
		end
		--love.graphics.setCaption("Rebound "..love.timer.getFPS().."fps")
end

function love.keypressed(k)
	if k==" " then
		for _,b in ipairs(balls) do
			b:start()
		end
	end
	if k=="9" then
		ai1 = not ai1
	end
	if k=="0" then
		ai2 = not ai2
	end
	if k=="escape" then
		love.event.quit()
	end
end
